typedef int int32;

void liftMemory ( int n0, int32 *s0, int32 *s1, int32 *d1 )
  // forward TS-transform
{
  int n1 = n0 >> 1;
  int32 *ps0, *ps1, *pd1;
  int i;
    // split:
  ps0 = s0;
  ps1 = s1; pd1 = d1;
  for ( i = 0; i++ < n1; ) {
    *ps1++ = *ps0++;
    *pd1++ = *ps0++;
  }
    // S-transform:
  ps1 = s1; pd1 = d1;
  for ( i = 0; i++ < n1; ) {
    *pd1 -= *ps1;
    *ps1++ += (*pd1++ >> 1);
  }
    // predict:
  ps1 = s1; pd1 = d1;
  ps1[n1] = ps1[n1-1];                 // boundary
  ps1[-1] = ps1[0];
  for ( i = 0; i++ < n1; ) {
    *pd1++ += ((ps1[-1] - ps1[1] + 2) >> 2);
    ps1++;
  }
}

void unliftMemory ( int n0, int32 *s0, int32 *s1, int32 *d1 )
  // inverse TS-transform
{
  int n1 = n0 >> 1;
  int32 *ps0, *ps1, *pd1;
  int i;
    // predict*:
  ps1 = s1; pd1 = d1;
  ps1[n1] = ps1[n1-1];                 // boundary
  ps1[-1] = ps1[0];
  for ( i = 0; i++ < n1; ) {
    *pd1++ -= ((ps1[-1] - ps1[1] + 2) >> 2);
    ps1++;
  }
    // S-transform*:
  ps1 = s1; pd1 = d1;
  for ( i = 0; i++ < n1; ) {
    *ps1 -= (*pd1 >> 1);
    *pd1++ += *ps1++;
  }
    // merge:
  ps0 = s0;
  ps1 = s1; pd1 = d1;
  for ( i = 0; i++ < n1; ) {
    *ps0++ = *ps1++;
    *ps0++ = *pd1++;
  }
}
