/**
 * Directions codes.
 * Representation of the eight closest neighbours of a cell..
 */
interface Direction {

	/** {@value} - unknown, arbitrary.. */
  byte VOID = -1;

  /** {@value} stands for [ 0, 0] */
  byte STAY = 0;
  /** {@value} stands for [ 0,-1] */
  byte N  = 1;
  /** {@value} stands for [ 1,-1] */
  byte NE = 2;
  /** {@value} stands for [ 1, 0] */
  byte E  = 3;
  /** {@value} stands for [ 1, 1] */
  byte SE = 4;
  /** {@value} stands for [ 0, 1] */
  byte S  = 5;
  /** {@value} stands for [-1, 1] */
  byte SW = 6;
  /** {@value} stands for [-1, 0] */
  byte W  = 7;
  /** {@value} stands for [-1,-1] */
  byte NW = 8;

  /** Relative x-coordinate of an unit move. */
  byte[] DELTA_X = {  0,  0,  1,  1,  1,  0, -1, -1, -1 };
  /** Relative y-coordinate of an unit move. */
  byte[] DELTA_Y = {  0, -1, -1,  0,  1,  1,  1,  0, -1 };

}
