/**
 * Precision of this locator is based on user's intellect :-).
 */
class Map implements Locator {

  /** Map instances are of public use.. */
  public Map ()
  {}

  /** Maximum error for dull user (actually equals to {@value}). */
  final int MAX_ERROR = 5;

  /**
   * Precision (error) depends on user's intellect.
   * @see     #MAX_ERROR
   */
  public int[] getPosition ( Entity asker, int[] result )
  {
    if ( asker == null )
      return null;
    if ( result == null )
      result = new int[2];
    asker.exactPosition(result);
    double coef = 2 * MAX_ERROR * (1.0 - asker.intellect());
    double errX = coef * (Math.random() - 0.5);
    double errY = coef * (Math.random() - 0.5);
    result[0] += (int)errX;
    result[1] += (int)errY;
    return result;
  }

}
